#include <SoftwareSerial.h>

//sn74hc165(hardware pin) > arduino pin
//CLK INH(15) = 3 PB3
//Qh(9) = 4 PB4
//CLK(2) = 1 PB1
//SH/!LD(1) = 2 PB2
//SER(10) = other regesiter (or ground)

const int Qh = 4; 
const int LoadActive = 2; 
const int clockPinclockPin = 1; 
const int enablePin = 3; 

SoftwareSerial serialOut(-1, 0); // RX, TX=PB0 == 0

byte incoming; //8 bit values read in
const byte emptyReg = B11111111; //empty values


void setup() 
{                

  serialOut.begin(9600);
  OSCCAL = 140; //oscillator calibration offset (found by using my calibration loop code Oscillator_Calibration.ino)
  // Initialize each digital pin to either output or input
  // We are commanding the shift register with each pin with the exception of the serial
  // data we get back on the Qh line.
  pinMode(LoadActive, OUTPUT);
  pinMode(enablePin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(Qh, INPUT);


  digitalWrite(clockPin, HIGH);
  digitalWrite(LoadActive, HIGH);
  
  digitalWrite(LoadActive, LOW);
  delayMicroseconds(5); 
  digitalWrite(LoadActive, HIGH);
  delayMicroseconds(5);

}

// The part that runs to infinity and beyond
void loop() {

  incoming = read_shift_regs();
  if(incoming != emptyReg){

    print_byte(incoming); 
  } else {
    serialOut.print("-");
    digitalWrite(LoadActive, LOW);
    delayMicroseconds(5); 
    digitalWrite(LoadActive, HIGH);
    delayMicroseconds(5);
    delay(1000);
  }
  delayMicroseconds(500); 

}


byte read_shift_regs()
{
  byte the_shifted = 0;  

  pinMode(clockPin, OUTPUT);
  pinMode(Qh, INPUT);
  digitalWrite(clockPin, HIGH);
  digitalWrite(enablePin, LOW); 
  the_shifted = shiftIn(Qh, clockPin, LSBFIRST); 
  digitalWrite(enablePin, HIGH); 

  return the_shifted;

}

void print_byte(byte val)
{
    char x = char(val);  
    serialOut.print(x);
}
