

//pull the byte array - DONE
//convert to a string - DONE
//ignore idential strings - DONE
//make audio database - DONE
//crosscheck string and database - DONE
//add two letter consonants and dipthongs - DONE
//sound out last letter before word said - DONE
//sort out draw order so blocks update before word is said
//optimize checks
//plug memory leak

import processing.serial.*; //load external library for serial control
import ddf.minim.*; 

Minim minim;
AudioPlayer player;
PImage[] icons = new PImage[12]; //max number of letters in a word?

Serial myPort;    // The serial port
PFont myFont;     // The display font
String inString;  // Input string from serial port
int charcount; //
int eol = 45;      //end of line ASCII code for end of string symbol '-'
String lastword = "";


StringList dictionary; //string list containing all valid words for quick checking.
String validWords[];   //string array of words for slow checking.
String dipthongs[] = {"ae", "ao", "ai", "au", "ei", "eu", "oi", "ou", "ng", "wh"};
int updateDraw = 0;


void setup() {
  size(800,200);
  background(210,232,179);
  minim = new Minim(this);
  myFont = loadFont("ArialMT-18.vlw");
  textFont(myFont, 18);
  
  // List all connected serial ports:
  println(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600); //create serial device on the 2nd port avaliable
  myPort.bufferUntil(eol); //buffer the serial line until the line end character is read. '-'
  loadDictionary();
}



void draw() {
  
  inString = readSerial();
  
  if(inString.length() > 12){ //why 12? wish i had commented this
    
    inString = inString.substring(0, inString.indexOf(eol)); //remove the end of line char from the string
    if(lastword.equals(inString) == false){
      drawLinks(inString);
    }
    lastword = inString;
  }
}

void drawLinks(String makeWords){
  switch (wordLookup(makeWords)) {
        case 0:
          //do nothing
        break;
        case 1:
          drawBlocks(makeWords.length(), makeWords);
          soundItOut(makeWords);
        break;
        case 2:
          drawBlocks(makeWords.length(), makeWords);
          soundItOut(makeWords);
          player = minim.loadFile("words/"+makeWords + ".mp3");
          player.play();
          while(player.isPlaying() == true){
        //wait for sound to finish before playing next one.
        }
        break;
      }
}

void loadDictionary() {
  /* loads all the words from the wordlist.txt file in the data folder into,
  a string array for char lookup and a stringlist for word lookup */
  dictionary = new StringList();
  validWords = loadStrings("wordlist.txt");
  for(int x = 0; x < validWords.length; x++){
    dictionary.append(validWords[x]);
  }
  println(dictionary);
}



void loadImages() {
  //icons = new PImage[12];
 // icons[0] = loadImage("/images/a.png"
}

int wordLookup(String currentBlocks){
  /*checks to see if the String passed to this function is in our dictionary of words,
  if it the DO SOMETHING TO TRIGGER THE SOUND AND UPDATE THIS COMMENT.
  if not check to see if the string has the potential to be a word in our dictionary,
  if so DO SOMETING TO SOUND OUT HE LETTERS AND UPDATE THIS COMMENT.*/
  //return 0 if invalid, 2 for a valid word, and 1 for a partial word.
  dictionary.shuffle(); //have abit of a shffule, might help with lag???
    if(dictionary.hasValue(currentBlocks) == true){
      println("found word: " + currentBlocks);
      return 2;
  } else {
    for(int x = 0; x < dictionary.size(); x++){
      String scanning = dictionary.get(x);
      if(scanning.indexOf(currentBlocks) == 0){
        println("found  " + currentBlocks + "  in " + dictionary.get(x));
        return 1;
      } else {
        //println("not in dictionary[" + x + "]");
      }
    }
    println("not Found" + currentBlocks + " does not begin any word");
    return 0;
  }
}

void soundItOut(String letters){
  /*takes a string and sounds out each letter, checks for two letter dipthongs & consonantes*/
  IntList dips = new IntList();
  for(int i = 0; i < dipthongs.length; i ++){ //loop through & identify any dipthongs in the string
    int startAt = 0;
    while(letters.indexOf(dipthongs[i], startAt) != -1){
      dips.append(letters.indexOf(dipthongs[i], startAt));
      startAt = letters.indexOf(dipthongs[i], startAt)+1;
    }
  }
    for(int i = 0; i < letters.length(); i ++){
      if(dips.size() != 0){
        if(dips.hasValue(i)){ //identify when the dipthong comes up and say it instead of each character individually
          println("found dips at:" + i);
          player = minim.loadFile("letters/" + letters.charAt(i) + letters.charAt(i+1) + ".mp3");
        } else {
          player = minim.loadFile("letters/" + letters.charAt(i) + ".mp3");
        }
        if(dips.hasValue(i-1)){ //skip pronouncing the second character in the dipthong
          println("skipping:" + (i));
          player = null; 
        }
      } else {
        player = minim.loadFile("letters/" + letters.charAt(i) + ".mp3");
      }
      if(player != null){
        player.play();
        while(player.isPlaying() == true){
        //wait for sound to finish before playing next one.
        }
      }
      
    }
}

void drawBlocks(int blockCount, String word){
  /* draws blocks on the screen to represent the characters on the block chain*/
  background(210,232,179);
  int blockSize =150;// 200/blockCount;
  if(blockSize > 150){blockSize = 150;}
  for(int i = 0; i < word.length(); i ++){
  //  stroke(0, 50, 100);
   // fill(200, 200, 200);
   // rect(blockSize*(i+1),50,blockSize,blockSize,3);
   // fill(0, 102, 153);
   // text(word.charAt(i), (blockSize*(i+1))+(blockSize/2), 50+(blockSize/2));
    icons[i] = loadImage("/images/"+word.charAt(i)+".png");
    image(icons[i], blockSize*(i+1), 25);
  }
  
}

String readSerial() {
  String output = "";
    while (myPort.available() > 0) {
    // Expand array size to the number of bytes you expect:
    byte[] inBuffer = new byte[15];
    myPort.readBytesUntil(eol, inBuffer);
    if (inBuffer != null) {
      String myString = new String(inBuffer);
      //inString = myString;
      //int empty = myString.indexOf('-');
     // inString = myString.substring(0, empty);
     // inString = myString;
     // print(empty);
      //println(inString);
      output = myString;
    } 
  }
  return output;
  
}
/*
void serialEvent(Serial p) {
  inString = p.readString();
  inString = inString.substring(0, inString.length()-1);
  charcount = 0;
  int startpoint = 0;
  int foundat = 0;
  charcount = 0;
  while(foundat != -1){
  foundat = inString.indexOf(':', foundat);
    if(foundat != -1){
      charcount ++;
      print(foundat);
    }
  }
}
*/
